%global scala_short_version 2.10
Name:          dispatch-classic
Version:       0.8.9
Release:       1%{?dist}
Summary:       Scala library for accessing HTTP services
License:       LGPLv3
URL:           http://dispatch-classic.databinder.net/
Source0:       https://github.com/dispatch/dispatch/archive/%{version}.tar.gz
# Default use sbt, avoid circular dep
Source1:       dispatch-build.xml

Source2:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-core_%{scala_short_version}/%{version}/dispatch-core_%{scala_short_version}-%{version}.pom
Source3:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-futures_%{scala_short_version}/%{version}/dispatch-futures_%{scala_short_version}-%{version}.pom
Source4:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-http_%{scala_short_version}/%{version}/dispatch-http_%{scala_short_version}-%{version}.pom
Source5:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-http-json_%{scala_short_version}/%{version}/dispatch-http-json_%{scala_short_version}-%{version}.pom
Source6:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-json_%{scala_short_version}/%{version}/dispatch-json_%{scala_short_version}-%{version}.pom
Source7:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-jsoup_%{scala_short_version}/%{version}/dispatch-jsoup_%{scala_short_version}-%{version}.pom
Source8:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-oauth_%{scala_short_version}/%{version}/dispatch-oauth_%{scala_short_version}-%{version}.pom
Source9:       http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-tagsoup_%{scala_short_version}/%{version}/dispatch-tagsoup_%{scala_short_version}-%{version}.pom

# Unable to build these modules
%if 0
Source10:      http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-gae_%{scala_short_version}/%{version}/dispatch-gae_%{scala_short_version}-%{version}.pom
Source11:      http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-mime_%{scala_short_version}/%{version}/dispatch-mime_%{scala_short_version}-%{version}.pom
Source12:      http://oss.sonatype.org/content/repositories/releases/net/databinder/dispatch-nio_%{scala_short_version}/%{version}/dispatch-nio_%{scala_short_version}-%{version}.pom
%endif

# Remove scala-actors refs
Patch0:        dispatch-0.8.9-no-scala-actors.patch

BuildRequires: java-devel
BuildRequires: javapackages-tools

BuildRequires: ant

BuildRequires: mvn(commons-codec:commons-codec)
BuildRequires: mvn(commons-logging:commons-logging)
BuildRequires: mvn(org.apache.httpcomponents:httpclient)
BuildRequires: mvn(org.apache.httpcomponents:httpcore)
BuildRequires: mvn(org.ccil.cowan.tagsoup:tagsoup)
BuildRequires: mvn(org.jsoup:jsoup)
BuildRequires: mvn(org.scala-lang:scala-compiler)
BuildRequires: mvn(org.scala-lang:scala-library)

%if 0
# Unavailable build deps
# Module dispatch-gae
BuildRequires: mvn(com.google.appengine:appengine-api-1.0-sdk:1.5.5)
# Module dispatch-nio
BuildRequires: mvn(org.apache.httpcomponents:httpasyncclient:4.0-alpha1)
# Module dispatch-futures dispatch-mime TODO use https://github.com/akka/akka/tree/master/akka-actor
BuildRequires: mvn(org.scala-lang:scala-actors)
# Test deps
BuildRequires: mvn(org.eclipse.jetty.aggregate:jetty-server:7.5.4.v20111024)
BuildRequires: mvn(org.scala-tools.testing:specs_2.10:1.6.9)
# Unused deps
# Module dispatch-mime
BuildRequires: mvn(org.apache.httpcomponents:httpmime)
BuildRequires: mvn(org.apache.james:apache-mime4j-core)
%endif

Requires:      mvn(commons-logging:commons-logging)
Requires:      mvn(org.apache.httpcomponents:httpclient)
Requires:      mvn(org.ccil.cowan.tagsoup:tagsoup)
Requires:      mvn(org.jsoup:jsoup)
Requires:      mvn(org.scala-lang:scala-library)

Requires:      java
Requires:      javapackages-tools
BuildArch:     noarch

%description
Dispatch is a library for conducting HTTP interaction.
You tell it what to do in pure and uninhibited Scala,
and Dispatch carries out your orders using its
trusty HttpClient backend. 

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n dispatch-%{version}
# Cleanup
find -name '*.class' -print -delete
find -name '*.jar' -print -delete

cp -p %{SOURCE1} build.xml
sed -i "s|@VERSION@|%{version}|" build.xml

%patch0 -p0

cp -p %{SOURCE3} futures-pom.xml
%pom_remove_dep :scala-actors futures-pom.xml

# see https://github.com/dispatch/dispatch/pull/81
sed -i "s,case object JsTrue extends JsBoolean(true),object JsTrue extends JsBoolean(true), \
 ;s,case object JsFalse extends JsBoolean(false),object JsFalse extends JsBoolean(false)," \
 json/src/main/scala/Json.scala

%build

ant dist doc

%install

mkdir -p %{buildroot}/%{_javadir}/%{name}
install -m 644 target/dispatch-*.jar %{buildroot}/%{_javadir}/%{name}/

mkdir -p %{buildroot}/%{_mavenpomdir}
install -pm 644 %{SOURCE2} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-core.pom
%add_maven_depmap JPP.%{name}-dispatch-core.pom %{name}/dispatch-core.jar

install -pm 644 futures-pom.xml %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-futures.pom
%add_maven_depmap JPP.%{name}-dispatch-futures.pom %{name}/dispatch-futures.jar

install -pm 644 %{SOURCE4} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-http.pom
%add_maven_depmap JPP.%{name}-dispatch-http.pom %{name}/dispatch-http.jar

install -pm 644 %{SOURCE5} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-http-json.pom
%add_maven_depmap JPP.%{name}-dispatch-http-json.pom %{name}/dispatch-http-json.jar

install -pm 644 %{SOURCE6} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-json.pom
%add_maven_depmap JPP.%{name}-dispatch-json.pom %{name}/dispatch-json.jar

install -pm 644 %{SOURCE7} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-jsoup.pom
%add_maven_depmap JPP.%{name}-dispatch-jsoup.pom %{name}/dispatch-jsoup.jar

install -pm 644 %{SOURCE8} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-oauth.pom
%add_maven_depmap JPP.%{name}-dispatch-oauth.pom %{name}/dispatch-oauth.jar

install -pm 644 %{SOURCE9} %{buildroot}/%{_mavenpomdir}/JPP.%{name}-dispatch-tagsoup.pom
%add_maven_depmap JPP.%{name}-dispatch-tagsoup.pom %{name}/dispatch-tagsoup.jar

mkdir -p %{buildroot}/%{_javadocdir}/%{name}
cp -rp target/apidocs/* %{buildroot}/%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/%{name}
%doc LICENSE.txt README.markdown

%files javadoc
%{_javadocdir}/%{name}
%doc LICENSE.txt

%changelog
* Tue Jan 28 2014 gil cattaneo <puntogil@libero.it> 0.8.9-1
- initial rpm